/*
    PIP - Platform Independent Primitives
    C++ code info structs
    Copyright (C) 2016  Ivan Pelipenko peri4ko@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "picodeinfo.h"


PIString PICodeInfo::EnumInfo::memberName(int value_) const {
	piForeachC (PICodeInfo::EnumeratorInfo & e, members)
		if (e.value == value_)
			return e.name;
	return PIString();
}


int PICodeInfo::EnumInfo::memberValue(const PIString & name_) const {
	piForeachC (PICodeInfo::EnumeratorInfo & e, members)
		if (e.name == name_)
			return e.value;
	return -1;
}


PIMap<PIString, PICodeInfo::ClassInfo * > * PICodeInfo::classesInfo;
PIMap<PIString, PICodeInfo::EnumInfo * > * PICodeInfo::enumsInfo;

bool __PICodeInfoInitializer__::_inited_ = false;
